unit Players;

interface

uses Sysutils;

Type
        TNaam=String[10];
        TVanAfPunt = (Type301, Type501);
        PuntenLijst=Array of byte;

        FileRec=Record
          LengteScore:Byte;
          Moment     :TDateTime;
          WType      :TVanAfPunt;
          Naam1      :TNaam;
          Naam2      :TNaam;
        end;

        TPlayers=Class
            Naam:TNaam;
            Punten:PuntenLijst;
            Function P100:Integer;
            Function P140:Integer;
            Function P180:Integer;
            Function Gemideld:real;
            Function PuntenTotaal:Integer;
          private
            Constructor Create(Name:TNaam);
            Function ZoekPUNTEN(Start,Einde:Byte):Integer;
        end;
        
        TWedstrijd=Class
            DatumTijd    :TDateTime;
            Player1      :TPlayers;
            Player2      :TPlayers;
            WedstrijdType:TVanAfPunt; //301 of 501
            FromFile     :Boolean;
            Constructor Create(Naam1,Naam2:TNaam;WedType:TVanAfPunt);
            Procedure AddPunt(const Punt:Byte);
            function  RemovePunt:Byte;
            function AanBeurt:TPlayers;
        end;

        
implementation

Procedure ZetPunt(var A:PuntenLijst;P:Byte);
begin
        Setlength(A,Length(A)+1);
        A[Length(A)-1]:=P;
end;

Function WegPunt(var A:PuntenLijst):Byte;
begin
        if length(A)<=0 then exit;
        Result:=A[Length(A)-1];
        Setlength(A,Length(A)-1);
end;

function TWedstrijd.AanBeurt:TPlayers;
var i:Integer;
begin
        i:=Length(Player1.Punten);
        if i>Length(Player2.Punten) then
                Result:=Player2
        else
                Result:=Player1;
end;

Function  TWedstrijd.RemovePunt:Byte;
Var i:Integer;
begin
        i:=Length(Player1.Punten);
        if i>Length(Player2.Punten) then
                Result:=WegPunt(Player1.Punten)
        else
                Result:=WegPunt(Player2.Punten);
end;

Procedure TWedstrijd.AddPunt(const Punt:Byte);
var i:Integer;
begin
        i:=Length(Player1.Punten);
        if i>Length(Player2.Punten) then
                ZetPunt(Player2.Punten,Punt)
        else
                ZetPunt(Player1.Punten,Punt);
end;

Constructor TWedstrijd.Create(Naam1,Naam2:TNaam;WedType:TVanAfPunt);
begin
        Player1:=TPlayers.Create(Naam1);
        Player2:=TPlayers.Create(Naam2);
        WedstrijdType:=WedType;
        DatumTijd:=Now;
end;

Constructor TPlayers.Create(Name:TNaam);
begin
        Naam:=Name;
        Setlength(Punten,0);
end;

Function TPlayers.PuntenTotaal:Integer;
var i,Som:Integer;
begin
        Som:=0;
        For i:=1 to Length(Punten) do
        begin
                Inc(Som,Punten[i-1]);
        end;
        Result:=Som;
end;

Function TPlayers.ZoekPUNTEN(Start,Einde:Byte):Integer;
var i,som:Integer;
begin
        som:=0;
        for i:=0 to length(Punten)-1 do
                if (punten[i]>=start) and (punten[i]<=Einde) then
                        inc(Som);
        result:=Som;
end;

Function TPlayers.P100:Integer;
begin
        Result:=ZoekPUNTEN(100,139);
end;

Function TPlayers.P140:Integer;
begin
        Result:=ZoekPUNTEN(140,179);
end;

Function TPlayers.P180:Integer;
begin
        Result:=ZoekPUNTEN(180,180);
end;

Function TPlayers.Gemideld:real;
var i,som:Integer;
begin
        som:=0;
        for i:=0 to length(Punten)-1 do
                inc(som, punten[i]);
        if length(Punten)>0 then
                result:=(Som/length(Punten))
        else
                result:=0;
end;

end.
