unit SaveBestand;

interface
Uses
        classes,Players;
Type
        TBestand=class
          public
            Function VanBestand(Bestand:String ;Const index:Integer):TWedstrijd;
            Procedure WedstrijdNaarBestand(Bestand:String;W:TWedstrijd);
            Function  AantWedstrijden:Integer;
            Function  Namen:TStringList;
            Function  FileNaam:String;
          private
            AantalWedstrijden:Integer;
            AlleNamen:TStringList;
            FileName:String;
            Function  LeesArr(const F:File;const Leng:Byte):PuntenLijst;
            Procedure NaamNaarList(const N:String);
            Procedure ResetW;
            Procedure PuntenNaarBestand(Const F:File;const a:PuntenLijst);
        end;

implementation

Function FileExists(const FileName: string): Boolean;

{ Boolean function that returns True if the file exists; otherwise,
  it returns False. Closes the file if it exists. }
 var
  F: file;
begin
  {$I-}
  AssignFile(F, FileName);
  FileMode := 0;  {Set file access to read only }
  Reset(F);
  CloseFile(F);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

Function TBestand.AantWedstrijden:Integer;
begin
        Result:=AantalWedstrijden;
end;

Function TBestand.Namen:TStringList;
begin
        Result:=AlleNamen;
end;

Function TBestand.FileNaam:String;
begin
        Result:=FileName;
end;

Procedure TBestand.PuntenNaarBestand(Const F:File;const a:PuntenLijst);
Var i:Integer;
    c:char;
begin
        For i:=0 to Length(a)-1 do
        begin
                c:=chr(a[i]);
                BlockWrite(F,c,1);
        end;
end;

Function TBestand.LeesArr(const F:File;const Leng:Byte):PuntenLijst;
var i:Integer;
    a:PuntenLijst;
    c:Char;
begin
        For i:=0 to (Leng-1) do
        begin
                Setlength(a,Length(a)+1);
                BlockRead(F,c,1);
                a[Length(a)-1]:=Ord(c);
        end;
        Result:=a;
end;

Procedure TBestand.ResetW;
begin
        //Filename:='';
        AantalWedstrijden:=0;
        AlleNamen:=TStringList.Create;
end;

Procedure TBestand.NaamNaarList(const N:String);
begin
        If AlleNamen.IndexOf(N)<0 then
                AlleNamen.Append(N);
end;

Function TBestand.VanBestand(Bestand:String;const index:Integer):TWedstrijd;
var F:File;
    weds      :TWedstrijd;
    HulpArr   :Array[0..1] of PuntenLijst;
    UitFile   :FileRec;
    AantW     :Byte;
begin
        If AlleNamen=nil then resetw;
        Filename:=Bestand;
        if Not(FileExists(Bestand)) then exit;
        AantW:=0;

        AssignFile(F, Bestand);
        FileMode := 0;//Read only
        Reset(F,1);
        try
                while not(Eof(F)) and (((AantalWedstrijden>=AantW) And (AantW<index)) Or (index=0))  do
                begin
                        Inc(AantW);

                        Weds:=nil;
                        BlockRead(F,UitFile,SizeOf(UitFile));
                        HulpArr[0]:= LeesArr(F,UitFile.LengteScore);//Lees score
                        HulpArr[1]:= LeesArr(F,UitFile.LengteScore);//Lees score

                        NaamNaarList(UitFile.Naam1);
                        NaamNaarList(UitFile.Naam2);
                        //Geselecteerde wedstrijd naar weds type
                        if (index=AantW) then
                        begin
                                weds:=TWedstrijd.Create(UitFile.Naam1 ,UitFile.Naam2 ,UitFile.WType);
                                weds.DatumTijd :=UitFile.Moment;
                                Setlength(weds.Player1.Punten,UitFile.LengteScore);
                                Setlength(weds.Player2.Punten,UitFile.LengteScore);
                                Weds.Player1.Punten:=HulpArr[0];
                                Weds.Player2.Punten:=HulpArr[1];
                        end;
                end;
        except
                Weds:=Nil;
                ResetW;
        end;
        CloseFile(F);
        AantalWedstrijden:=Aantw;
        result:=Weds;
end;

Procedure TBestand.WedstrijdNaarBestand(Bestand:String;W:TWedstrijd);//
var FromF,ToF:File;
    Buf      :Array[1..1024] of Byte;
    NumRead,NumWritten:Integer;
    NaarFile :FileRec;
begin
        // zet length van de score gelijk met de langste.
        NaarFile.LengteScore :=Length(W.Player1.Punten);
        If NaarFile.LengteScore<Length(W.Player2.Punten) then
                NaarFile.LengteScore :=Length(W.Player2.Punten);
        Setlength(w.Player1.Punten,NaarFile.LengteScore);
        Setlength(w.Player2.Punten,NaarFile.LengteScore);

        NaarFile.Moment:=W.DatumTijd;
        NaarFile.Naam1 :=TNaam(W.Player1.Naam);
        NaarFile.Naam2 :=TNaam(W.Player2.Naam);
        NaarFile.WType :=W.WedstrijdType;

        If FileExists(Bestand) then //BestandBestaat-> naar DATA.OLD
        begin
                If FileExists('DATA.OLD') then//Oude OLD verwijderen.
                begin
                        AssignFile(FromF,'DATA.OLD');
                        Erase(FromF);
                end;
                AssignFile(FromF,Bestand);
                Rename(FromF,'DATA.OLD');
                FileMode:=0;
                Reset(FromF,1);
                  AssignFile(ToF,Bestand);
                  ReWrite(ToF,1);
                  repeat //OudBestand overzetten naar NieuwBestand
                        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
                        BlockWrite(ToF, Buf, NumRead, NumWritten);
                  until (NumRead = 0) or (NumWritten <> NumRead);
                  CloseFile(FromF);
                  //Nieuw Wedstrijd erachter bij.
                        BlockWrite(ToF,NaarFile,SizeOf(NaarFile));
                        PuntenNaarBestand(ToF,W.Player1.Punten); //Punten1
                        PuntenNaarBestand(ToF,W.Player2.Punten); //Punten2
                  CloseFile(ToF);
        end
        else
        begin
                AssignFile(ToF,Bestand);
                ReWrite(ToF,1);
                BlockWrite(ToF,NaarFile,SizeOf(NaarFile));
                PuntenNaarBestand(ToF,W.Player1.Punten); //Punten1
                PuntenNaarBestand(ToF,W.Player2.Punten); //Punten2
                CloseFile(ToF);
        end;
end;

end.
